import { useEffect, useState } from "react";
import "./App.css";
import Layout from "./Components/Base/Layout";
import Tasks from "./Components/TopLevel/Tasks";
import Form from "./Todo/Form";

function App() {
  const [task, setTask] = useState([]);
  const addTask = async (data) => {
    const res = await fetch(`http://192.168.1.91:5000/task`, {
      method: "POST",
      headers: { "Content-type": "application/json" },
      body: JSON.stringify(data),
    });
    const result = await res.json();
    setTask([...task, result]);
  };

  const getTask = async () => {
    const taskData = await fetch("http://192.168.1.91:5000/task");
    const response = await taskData.json();
    setTask(response);
  };
  const getTaskById = async (id) => {
    const tasktracker = await fetch(`http://192.168.1.91:5000/task/${id}`);
    const response = await tasktracker.json();
    return response;
  };
  const remainder = async (datas) => {
    const toogle = await getTaskById(datas.id);
    const result = { ...toogle, checked: !toogle.checked };

    const res = await fetch(`http://192.168.1.91:5000/task/${datas.id}`, {
      method: "PUT",
      headers: { "Content-type": "application/json" },
      body: JSON.stringify(result),
    });
    const data = await res.json();
    setTask(
      task.map((e) => (e.id === data.id ? { ...e, checked: data.checked } : e))
    );
  };
  const deleteTask = async (data) => {
    var result = window.confirm("Want to delete?");
    if (result) {
      //Logic to delete the item

      await fetch(`http://192.168.1.91:5000/task/${data.id}`, {
        method: "DELETE",
      });
      setTask(task.filter((e) => e.id !== data.id));
    }
  };
  useEffect(() => {
    getTask();
  }, []);

  return (
    <div className="App">
      <Layout count={task.filter((e) => !e.checked).length}>
        {task.length > 0 && (
          <Tasks
            tasksData={task}
            handleClick={remainder}
            handleCloses={deleteTask}
          />
        )}
        <Form bottom={true} addtask={addTask} />
      </Layout>
    </div>
  );
}

export default App;
