import React from "react";
import PropTypes from "prop-types";
import "../Button/button.css";

function Button({ label, backgroundColor, handleClick, size }) {
  const style = {
    backgroundColor,
  };
  return (
    <div>
      <button className={`btn btn-${size}`} style={style} onClick={handleClick}>
        {label}
      </button>
    </div>
  );
}

Button.propTypes = {
  label: PropTypes.string,
  backgroundColor: PropTypes.string,
  handleClick: PropTypes.func,
};

Button.defaultProps = {
  label: "Submit",
  backgroundColor: "white",
};

export default Button;
